///////////////////////////////////////////////////////////////
// RgNX CBSchComment ̓̒`s܂

#include "stdafx.h"
#include "NL.h"
#include "BSchObj.h"
#include "BSchCmnt.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define Y_OFFSET 2


//IuWFNg̕
CBSchObj* CBSchComment::Duplicate()
{
	CBSchComment* pObj=new CBSchComment;
	if(!pObj) return NULL;
	pObj->m_dwType		=this->m_dwType;
	pObj->m_dwStus		=this->m_dwStus;
	pObj->m_nMoveFrom	=this->m_nMoveFrom;
	pObj->m_p0			=this->m_p0;
	pObj->m_nLayer		=this->m_nLayer;
	if(this->m_psz){
		pObj->m_psz=new char[lstrlen(this->m_psz)+1];
		lstrcpy(pObj->m_psz,this->m_psz);
	}
	return (CBSchObj*)pObj;
}

//f[^Lǂ𒲂ׂ
BOOL CBSchComment::IsValid()
{
	if(!m_psz) return FALSE;
	if(lstrlen(m_psz)==0) return FALSE;
	return TRUE;
}	


////////////////////////////////////////////////////////////////////////////////
//CE2t@Co
#pragma pack(1)		//\̂̋EPoCgPʂɕύX

//t@Cւ̏
//TRUEBsFALSEԂ
//Rg̃wb_[ƃRĝQɕď
BOOL CBSchComment::WriteCE2(CFile* pFile,CPoint* pOrigin /* =NULL*/)
{
	int nStrLen,nx,ny;
	BOOL bResult=TRUE;

	if(!m_psz) return TRUE; 
	nStrLen=lstrlen(m_psz);
	if(nStrLen==0) return TRUE;

	if(nStrLen>63)nStrLen=63;		//

	struct{			//ݗp̍\
		BYTE	bId;			//ID
		BYTE	bStus;			//Xe[^X
		short	x;				//wW
		short	y;				//xW
		short   reserved1[2];	//\
		short	datasize;		//f[^̃TCY
		BYTE	btype;			//0:c8dot  1:c16dot
		BYTE	bcharcount;		//
	}ce2comment;

	if(pOrigin){
		nx=pOrigin->x;
		ny=pOrigin->y;
	}else{
		nx=0;
		ny=0;
	}
	ce2comment.bId  	  =CE2_COMMENT;
	//ce2comment.bStus	  =0;
	ce2comment.bStus	=(m_nLayer & 0x0F)<<4;	//1998/06/27
	ce2comment.x		  =m_p0.x-nx;
	ce2comment.y		  =m_p0.y-ny;
	ce2comment.datasize   =sizeof(ce2comment)+nStrLen;
	ce2comment.btype	  =(BYTE)(m_dwType&1);
	ce2comment.bcharcount =nStrLen;
	try{
		pFile->Write(&ce2comment,sizeof(ce2comment));
	}
	catch(CFileException *e){
		if(e->m_cause!=CFileException::none) bResult=FALSE;
		e->Delete();
	}
	
	if(bResult){
		try{
			pFile->Write(m_psz,nStrLen);
		}
		catch(CFileException *e){
			if(e->m_cause!=CFileException::none) bResult=FALSE;
			e->Delete();
		}
	}
	return bResult;
}



//t@C̓ǂݍ
BOOL CBSchComment::ReadCE2(CFile* pFile,BYTE bCE2Id,CPoint* pOrigin/* =NULL*/)
{
	int nx,ny,n;
	struct{			//ǂݍݗp̍\
		BYTE	bStus;			//Xe[^X
		short	x;				//wW
		short	y;				//xW
		short   reserved1[2];	//\
		short	datasize;		//f[^̃TCY
		BYTE	btype;			//0:c8dot  1:c16dot
		BYTE	bcharcount;		//
	}ce2comment;


	if(bCE2Id!=CE2_COMMENT) return FALSE;
	UINT uResult=pFile->Read(&ce2comment,sizeof(ce2comment));
	if(uResult<sizeof(ce2comment)) return FALSE;

	if(pOrigin){
		nx=pOrigin->x;
		ny=pOrigin->y;
	}else{
		nx=0;
		ny=0;
	}
    m_dwType=ce2comment.btype&1;
    m_dwStus=0;	
	m_p0.x=(int)ce2comment.x+nx;
	m_p0.y=(int)ce2comment.y+ny;
	//m_bSetSize=FALSE;
	n=ce2comment.datasize-(sizeof(ce2comment)+1);	//u+1v͏ʂœǂݍݍς݂̂PoCg
	if(ce2comment.bcharcount>n){	//Rgf[^̃t@C̃TCYƕ
		TRACE("\n datasize error. CBSchComment::ReadCE2()");
		return FALSE;
	}
	m_psz=new char[ce2comment.bcharcount+1];	//̃m
	uResult=pFile->Read(m_psz,n);
	if(uResult<(UINT)n) return FALSE;	//LXgȂƎv
	*(m_psz+ce2comment.bcharcount)=0;
	//C[̐ݒ
	m_nLayer=(ce2comment.bStus & 0xF0)>>4;

	return TRUE;
}

#pragma pack()		//\̂̋EftHglɖ߂






