///////////////////////////////////////////////////////////////
// zNX BSchBus ̓̒`s܂
//

#include "stdafx.h"
#include "NL.h"
#include "BSchObj.h"
#include "BSchLine.h"
#include "BSchBus.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



//IuWFNg̕
CBSchObj* CBSchBus::Duplicate()
{
	CBSchBus* pObj=new CBSchBus;
	if(!pObj) return NULL;
	pObj->m_dwType=this->m_dwType;
	pObj->m_dwStus=this->m_dwStus;
	pObj->m_nMoveFrom=this->m_nMoveFrom;
	pObj->m_p0    =this->m_p0;
	pObj->m_p1    =this->m_p1;
	pObj->m_nLayer=this->m_nLayer;
	return (CBSchObj*)pObj;
}

////////////////////////////////////////////////////////////////////////////////
//CE2t@Co
#pragma pack(1)		//\̂̋EPoCgPʂɕύX

//t@Cւ̏
//TRUEBsFALSEԂ
BOOL CBSchBus::WriteCE2(CFile* pFile,CPoint* pOrigin /*=NULL*/)
{
	int nx,ny;
	BOOL bResult=TRUE;
	struct{				//ݗp̍\
		BYTE	bId;	//ID
		BYTE	bStus;	//Xe[^X
		short	x0;		//_ÔwW
		short	y0;		//      xW
		short	x1;		//_P̂wW
		short	y1;		//      xW
	}ce2wire;

	if(pOrigin){
		nx=pOrigin->x;
		ny=pOrigin->y;
	}else{
		nx=0;
		ny=0;
	}


	ce2wire.bId  	=CE2_BUS;
	//ce2wire.bStus	=0;
	ce2wire.bStus	=(m_nLayer & 0x0F)<<4;	//1998/06/27
	ce2wire.x0		=m_p0.x-nx;
	ce2wire.y0		=m_p0.y-ny;
	ce2wire.x1		=m_p1.x-nx;
	ce2wire.y1		=m_p1.y-ny;
	try{
		pFile->Write(&ce2wire,sizeof(ce2wire));
	}
	catch(CFileException *e){
		if(e->m_cause!=CFileException::none) bResult=FALSE;
		e->Delete();
	}
	return bResult;
}

//t@C̓ǂݍ
//TRUEBsFALSEԂ
//ĂяoOIDʂ̂߂ɂPoCgǂݍł
BOOL CBSchBus::ReadCE2(CFile* pFile,BYTE bCE2Id,CPoint* pOrigin /*=NULL*/)
{
	int nx,ny,p;
	struct{				//ǂݍݗp̍\
		BYTE	bStus;	//Xe[^X
		short	x0;		//_ÔwW
		short	y0;		//      xW
		short	x1;		//_P̂wW
		short	y1;		//      xW
	}ce2wire;
	if(bCE2Id!=CE2_BUS) return FALSE;

	UINT uResult=pFile->Read(&ce2wire,sizeof(ce2wire));
	if(uResult<sizeof(ce2wire)) return FALSE;

	if(pOrigin){
		nx=pOrigin->x;
		ny=pOrigin->y;
	}else{
		nx=0;
		ny=0;
	}
    m_dwType=0;
    m_dwStus=0;	
	m_p0.x=(int)ce2wire.x0+nx;
	m_p0.y=(int)ce2wire.y0+ny;
	m_p1.x=(int)ce2wire.x1+nx;
	m_p1.y=(int)ce2wire.y1+ny;

	if(m_p0.y==m_p1.y){//Ȃ...
		//m_p0.x<m_p1.xۏ؂
		if(m_p0.x > m_p1.x){p=m_p0.x; m_p0.x=m_p1.x; m_p1.x=p;}
	}else if(m_p0.x==m_p1.x){//Ȃ...
		//m_p0.y<m_p1.yۏ؂
		if(m_p0.y > m_p1.y){p=m_p0.y; m_p0.y=m_p1.y; m_p1.y=p;}
	}
	//C[̐ݒ
	m_nLayer=(ce2wire.bStus & 0xF0)>>4;
	return TRUE;
}

#pragma pack()		//\̂̋EftHglɖ߂
